#pragma once
#include <memory>

#define GG_CLASS(T) GG_DECL(T); class T : public GraphGame::Shared<T>, public std::enable_shared_from_this<T> {
#define GG_SUBCLASS(T, BASE) GG_DECL(T); class T : public BASE, public GraphGame::Shared<T> { public: using GraphGame::Shared<T>::create; using GraphGame::Shared<T>::getShared; private:
#define GG_ENDCLASS };
#define GG_DECL(T) class T; using T##P = std::shared_ptr<T>; using T##W = std::weak_ptr<T>;

namespace GraphGame {


	template<class T> class Shared {
	public:
		template<typename... Args>
			inline static std::shared_ptr<T> create(Args... args)
		{	
			return std::make_shared<T>(args...);
		}
		std::shared_ptr<T> getShared() {
			return std::dynamic_pointer_cast<T>( ((T*)this)->shared_from_this());
		}

		using P = std::shared_ptr<T>;
		using W = std::weak_ptr<T>;
	};
}

